Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class BoxView

    java.lang.Object
      |
      +--javax.swing.text.View
            |
            +--javax.swing.text.CompositeView
                  |
                  +--javax.swing.text.BoxView

Direct Known Subclasses:
  BlockView, ParagraphView, TableView, TableView.TableCell, TableView.TableRow, WrappedPlainView

public class BoxView
extends CompositeView

A view of a text model that arranges its children into a box. It might be useful to represent something like a collection of lines, paragraphs, list items, chunks of text, etc. The box is somewhat like that found in TeX where there is alignment of the children, flexibility of the children is considered, etc.

Fields inherited from class javax.swing.text.View
`BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`

Constructor Summary
`BoxView(Element elem, int axis)` Constructs a BoxView.

Method Summary
`protected void` | `baselineLayout(int targetSpan, int axis, int[] offsets, int[] spans)`
`protected SizeRequirements` | `baselineRequirements(int axis, SizeRequirements r)`
`protected SizeRequirements` | `calculateMajorAxisRequirements(int axis, SizeRequirements r)`
`protected SizeRequirements` | `calculateMinorAxisRequirements(int axis, SizeRequirements r)`
`void` | `changedUpdate(DocumentEvent e, java.awt.Shape a, ViewFactory f)` Gives notification from the document that attributes were changed in a location that this view is responsible for.
`protected void` | `childAllocation(int index, java.awt.Rectangle alloc)` Allocates a region for a child view.
`protected boolean` | `flipEastAndWestAtEnds(int position, Position.Bias bias)`
`float` | `getAlignment(int axis)` Determines the desired alignment for this view along an axis.
`int` | `getHeight()` The current height of the box.
`float` | `getMaximumSpan(int axis)` Determines the maximum span for this view along an axis.
`float` | `getMinimumSpan(int axis)` Determines the minimum span for this view along an axis.
`protected int` | `getOffset(int axis, int childIndex)` Fetch the offset of a particular childs current layout
`float` | `getPreferredSpan(int axis)` Determines the preferred span for this view along an axis.
`int` | `getResizeWeight(int axis)` Gets the resize weight.
`protected int` | `getSpan(int axis, int childIndex)` Fetch the span of a particular childs current layout
`protected View` | `getViewAtPoint(int x, int y, java.awt.Rectangle alloc)` Fetches the child view at the given point.
`int` | `getWidth()` The current width of the box.
`void` | `insertUpdate(DocumentEvent e, java.awt.Shape a, ViewFactory f)` Gives notification that something was inserted into the document in a location that this view is responsible for.
`protected boolean` | `isAfter(int x, int y, java.awt.Rectangle innerAlloc)` Determines if a point falls after an allocated region.
`protected boolean` | `isAllocationValid()` Are the allocations for the children still valid?
`protected boolean` | `isBefore(int x, int y, java.awt.Rectangle innerAlloc)` Determines if a point falls before an allocated region.
`protected void` | `layout(int width, int height)` Performs layout of the children.
`protected void` | `layoutMajorAxis(int targetSpan, int axis, int[] offsets, int[] spans)` Perform layout for the major axis of the box (i.e.
`protected void` | `layoutMinorAxis(int targetSpan, int axis, int[] offsets, int[] spans)` Perform layout for the minor axis of the box (i.e.
`java.awt.Shape` | `modelToView(int pos, java.awt.Shape a, Position.Bias b)` Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`void` | `paint(java.awt.Graphics g, java.awt.Shape allocation)` Renders using the given rendering surface and area on that surface.
`protected void` | `paintChild(java.awt.Graphics g, java.awt.Rectangle alloc, int index)` Paints a child.
`void` | `preferenceChanged(View child, boolean width, boolean height)` This is called by a child to indicated its preferred span has changed.
`void` | `removeUpdate(DocumentEvent e, java.awt.Shape a, ViewFactory f)` Gives notification that something was removed from the document in a location that this view is responsible for.
`void` | `replace(int offset, int length, View[] elems)` Invalidates the layout and resizes the cache of requests/allocations.
`void` | `setSize(float width, float height)` Sets the size of the view.
`int` | `viewToModel(float x, float y, java.awt.Shape a, Position.Bias[] bias)` Provides a mapping from the view coordinate space to the logical coordinate space of the model.

Methods inherited from class javax.swing.text.CompositeView
`append, getBottomInset, getChildAllocation, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextNorthSouthVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewAtPosition, getViewCount, getViewIndexAtPosition, insert, loadChildren, modelToView, removeAll, setInsets, setParagraphInsets, setParent`

Methods inherited from class javax.swing.text.View
`breakView, createFragment, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getParent, getStartOffset, getViewFactory, isVisible, modelToView, viewToModel`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BoxView

    public BoxView(Element elem,
                   int axis)

  Constructs a BoxView.
  Parameters:
    `elem` - the element this view is responsible for
    `axis` - either View.X_AXIS or View.Y_AXIS

Method Detail

### paintChild

    protected void paintChild(java.awt.Graphics g,
                              java.awt.Rectangle alloc,
                              int index)

  Paints a child. By default that is all it does, but a subclass can use this to paint things relative to the child.
  Parameters:
    `g` - the graphics context
    `alloc` - the allocated region to paint into
    `index` - the child index, >= 0 && < getViewCount()

### replace

    public void replace(int offset,
                        int length,
                        View[] elems)

  Invalidates the layout and resizes the cache of requests/allocations.
  Parameters:
    `offset` - the starting offset into the child views >= 0
    `length` - the number of existing views to replace >= 0
    `elems` - the child views to insert
  Overrides:
    replace in class CompositeView

### preferenceChanged

    public void preferenceChanged(View child,
                                  boolean width,
                                  boolean height)

  This is called by a child to indicated its preferred span has changed. This is implemented to throw away cached layout information so that new calculations will be done the next time the children need an allocation.
  Parameters:
    `child` - the child view
    `width` - true if the width preference should change
    `height` - true if the height preference should change
  Overrides:
    preferenceChanged in class View

### getResizeWeight

    public int getResizeWeight(int axis)

  Gets the resize weight. A value of 0 or less is not resizable.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Returns:
    the weight
  Throws:
    java.lang.IllegalArgumentException - for an invalid axis
  Overrides:
    getResizeWeight in class View

### setSize

    public void setSize(float width,
                        float height)

  Sets the size of the view. If the size has changed, layout is redone. The size is the full size of the view including the inset areas.
  Parameters:
    `width` - the width >= 0
    `height` - the height >= 0
  Overrides:
    setSize in class View

### paint

    public void paint(java.awt.Graphics g,
                      java.awt.Shape allocation)

  Renders using the given rendering surface and area on that surface.
  Parameters:
    `g` - the rendering surface to use
    `allocation` - the allocated region to render into
  Overrides:
    paint in class View
  See Also:
    `View.paint(java.awt.Graphics, java.awt.Shape)`

### modelToView

    public java.awt.Shape modelToView(int pos,
                                      java.awt.Shape a,
                                      Position.Bias b)
                               throws BadLocationException

  Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it. This makes sure the allocation is valid before letting the superclass do its thing.
  Parameters:
    `pos` - the position to convert >= 0
    `a` - the allocated region to render into
  Returns:
    the bounding box of the given position
  Throws:
    BadLocationException - if the given position does not represent a valid location in the associated document
  Overrides:
    modelToView in class CompositeView
  See Also:
    `View.modelToView(int, java.awt.Shape, javax.swing.text.Position.Bias)`

### viewToModel

    public int viewToModel(float x,
                           float y,
                           java.awt.Shape a,
                           Position.Bias[] bias)

  Provides a mapping from the view coordinate space to the logical coordinate space of the model.
  Parameters:
    `x` - x coordinate of the view location to convert >= 0
    `y` - y coordinate of the view location to convert >= 0
    `a` - the allocated region to render into
  Returns:
    the location within the model that best represents the given point in the view >= 0
  Overrides:
    viewToModel in class CompositeView
  See Also:
    `View.viewToModel(float, float, java.awt.Shape, javax.swing.text.Position.Bias[])`

### getAlignment

    public float getAlignment(int axis)

  Determines the desired alignment for this view along an axis. This is implemented to give the total alignment needed to position the children with the alignment points lined up along the axis orthoginal to the axis that is being tiled. The axis being tiled will request to be centered (i.e. 0.5f).
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Throws:
    java.lang.IllegalArgumentException - for an invalid axis
  Overrides:
    getAlignment in class View

### getPreferredSpan

    public float getPreferredSpan(int axis)

  Determines the preferred span for this view along an axis.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Throws:
    java.lang.IllegalArgumentException - for an invalid axis type
  Overrides:
    getPreferredSpan in class View

### getMinimumSpan

    public float getMinimumSpan(int axis)

  Determines the minimum span for this view along an axis.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Throws:
    java.lang.IllegalArgumentException - for an invalid axis type
  Overrides:
    getMinimumSpan in class View

### getMaximumSpan

    public float getMaximumSpan(int axis)

  Determines the maximum span for this view along an axis.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Throws:
    java.lang.IllegalArgumentException - for an invalid axis type
  Overrides:
    getMaximumSpan in class View

### insertUpdate

    public void insertUpdate(DocumentEvent e,
                             java.awt.Shape a,
                             ViewFactory f)

  Gives notification that something was inserted into the document in a location that this view is responsible for.
  Parameters:
    `e` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  Overrides:
    insertUpdate in class View
  See Also:
    `View.insertUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

### removeUpdate

    public void removeUpdate(DocumentEvent e,
                             java.awt.Shape a,
                             ViewFactory f)

  Gives notification that something was removed from the document in a location that this view is responsible for.
  Parameters:
    `e` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  Overrides:
    removeUpdate in class View
  See Also:
    `View.removeUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

### changedUpdate

    public void changedUpdate(DocumentEvent e,
                              java.awt.Shape a,
                              ViewFactory f)

  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  Parameters:
    `e` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  Overrides:
    changedUpdate in class View
  See Also:
    `View.changedUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

### isAllocationValid

    protected boolean isAllocationValid()

  Are the allocations for the children still valid?
  Returns:
    true if allocations still valid

### isBefore

    protected boolean isBefore(int x,
                               int y,
                               java.awt.Rectangle innerAlloc)

  Determines if a point falls before an allocated region.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `innerAlloc` - the allocated region. This is the area inside of the insets.
  Returns:
    true if the point lies before the region else false
  Overrides:
    isBefore in class CompositeView

### isAfter

    protected boolean isAfter(int x,
                              int y,
                              java.awt.Rectangle innerAlloc)

  Determines if a point falls after an allocated region.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `innerAlloc` - the allocated region. This is the area inside of the insets.
  Returns:
    true if the point lies after the region else false
  Overrides:
    isAfter in class CompositeView

### getViewAtPoint

    protected View getViewAtPoint(int x,
                                  int y,
                                  java.awt.Rectangle alloc)

  Fetches the child view at the given point.
  Parameters:
    `x` - the X coordinate >= 0
    `y` - the Y coordinate >= 0
    `alloc` - the parents inner allocation on entry, which should be changed to the childs allocation on exit.
  Returns:
    the view
  Overrides:
    getViewAtPoint in class CompositeView

### childAllocation

    protected void childAllocation(int index,
                                   java.awt.Rectangle alloc)

  Allocates a region for a child view.
  Parameters:
    `index` - the index of the child view to allocate, >= 0 && < getViewCount()
    `alloc` - the allocated region
  Overrides:
    childAllocation in class CompositeView

### layout

    protected void layout(int width,
                          int height)

  Performs layout of the children. The size is the area inside of the insets. This method calls the methods layoutMajorAxis and layoutMinorAxis as needed. To change how layout is done those methods should be reimplemented.
  Parameters:
    `width` - the width >= 0
    `height` - the height >= 0

### getWidth

    public final int getWidth()

  The current width of the box. This is the width that it was last allocated.

### getHeight

    public final int getHeight()

  The current height of the box. This is the height that it was last allocated.

### layoutMajorAxis

    protected void layoutMajorAxis(int targetSpan,
                                   int axis,
                                   int[] offsets,
                                   int[] spans)

  Perform layout for the major axis of the box (i.e. the axis that it represents). The results of the layout should be placed in the given arrays which represent the allocations to the children along the major axis.
  Parameters:
    `targetSpan` - the total span given to the view, which whould be used to layout the children.
    `axis` - the axis being layed out.
    `offsets` - the offsets from the origin of the view for each of the child views. This is a return value and is filled in by the implementation of this method.
    `spans` - the span of each child view. This is a return value and is filled in by the implementation of this method.

### layoutMinorAxis

    protected void layoutMinorAxis(int targetSpan,
                                   int axis,
                                   int[] offsets,
                                   int[] spans)

  Perform layout for the minor axis of the box (i.e. the axis orthoginal to the axis that it represents). The results of the layout should be placed in the given arrays which represent the allocations to the children along the minor axis.
  Parameters:
    `targetSpan` - the total span given to the view, which whould be used to layout the children.
    `axis` - the axis being layed out.
    `offsets` - the offsets from the origin of the view for each of the child views. This is a return value and is filled in by the implementation of this method.
    `spans` - the span of each child view. This is a return value and is filled in by the implementation of this method.

### calculateMajorAxisRequirements

    protected SizeRequirements calculateMajorAxisRequirements(int axis,
                                                              SizeRequirements r)

### calculateMinorAxisRequirements

    protected SizeRequirements calculateMinorAxisRequirements(int axis,
                                                              SizeRequirements r)

### baselineLayout

    protected void baselineLayout(int targetSpan,
                                  int axis,
                                  int[] offsets,
                                  int[] spans)

### baselineRequirements

    protected SizeRequirements baselineRequirements(int axis,
                                                    SizeRequirements r)

### getOffset

    protected final int getOffset(int axis,
                                  int childIndex)

  Fetch the offset of a particular childs current layout

### getSpan

    protected final int getSpan(int axis,
                                int childIndex)

  Fetch the span of a particular childs current layout

### flipEastAndWestAtEnds

    protected boolean flipEastAndWestAtEnds(int position,
                                            Position.Bias bias)

  Overrides:
    flipEastAndWestAtEnds in class CompositeView

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.